   /*
        *  Licensed Materials - Property of IBM
        *  5725-G92 (C) Copyright IBM Corp. 2011, 2013. All Rights Reserved.
        *  US Government Users Restricted Rights - Use, duplication or
        *  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
        */

package com.ContainerForAdvancedPages;

import android.os.Bundle;
import android.graphics.Color;
import android.webkit.CookieManager;
import android.webkit.CookieSyncManager;
import com.worklight.androidgap.WLDroidGap;

public class ContainerForAdvancedPages extends WLDroidGap {
	/**
     * onWLInitCompleted is called when the Worklight runtime framework initialization is complete
     */
	@Override
	public void onWLInitCompleted(Bundle savedInstanceState) {
	   // Additional initialization code from onCreate() was moved here
       CookieSyncManager.createInstance(appView.getContext());
       CookieManager.getInstance().removeSessionCookie();
 	   String resourceHome = getWLConfig().getProtocol() +"://"+ getWLConfig().getHost();
 	   String port = getWLConfig().getPort();
 	   //If port is 80, do not need use this port, otherwise need add port.
 	   if(Integer.parseInt(port)!=80){
 		   resourceHome+=":"+port;
	   }
	   loadUrl( resourceHome + "/conference", false) ;	// do not clear cache
	   appView.setBackgroundColor(Color.WHITE);	// set background to white to ensure errors display
	}


    @Override
    public void onCreate(Bundle savedInstanceState) { 
        super.onCreate(savedInstanceState);
        // Additional initialization code was moved to onWLInitCompleted()
    }


	public void loadUrl(String url) {
		loadUrl(url, false); // default is false
	}
}



